#include "CustomContainer.hpp"
#include "ItsWindow.hpp"
#include "ColorDef.hpp"
#include "helloworld.brh"

// RXgN^
CustomContainer::CustomContainer(Void) static_throws
{
    if (static_try()) {
        SetType(CODE_TYPE);
    }
}

// fXgN^
CustomContainer::~CustomContainer(Void)
{
}

// CustomContainer CX^X𐶐 NewInstance() ֐
CustomContainerSmp CustomContainer::NewInstance(SFCErrorPtr exception)
{
    return static_pointer_cast<CustomContainer>(Factory(:: new CustomContainer, exception));
}

// CustomContainer ̕`nh
Void CustomContainer::HandleRenderRequest(SFXGraphicsPtr graphics) const
{
    // 
    AEEStrokeStyle style;

    // `O̐LĂ
    style = graphics->GetStrokeStyle();

    // _ɐݒ肷
    graphics->SetStrokeStyle(STROKE_DOTTED);

    // CustomContainer ̃[J̈悩݂ۂɕ`悳̈ (̈) vZ
    // ͉̈z̈ƌ_OƂ̈TCŸ̗Ƃ̏dȂ蕔ɂȂ
    // ܂A`̓[J̈ɍs邽߁A̈̃ObhẂA
    // z̈̃ObhW}CiXɂlƂȂ
    SFXRectangle rx;
    rx.Set(GetVirtualBound());
    rx.Set(SFXGrid(-rx.GetX(), -rx.GetY()), GetRealBound().GetSize());

    // ̈拫EɍF̓_`悷
    graphics->DrawRectangle(rx, COLOR_BLACK);

    // ɖ߂
    graphics->SetStrokeStyle(style);

    return;
}

// tbNXXg{bNXRg[쐬Ezu
SFCError CustomContainer::Make(Void)
{
    SFZFlexListBoxControlSmp list;
    SFZFlexListBoxControl::ItemRec item;
    SFBShellSmp shell(SFBShell::GetInstance());
    SFBImageSmp normal(shell->LoadResImage("helloworld.bar", IDI_OBJECT_5001));
    SFBImageSmp select(shell->LoadResImage("helloworld.bar", IDI_OBJECT_5002));
    SFCError error(SFERR_NO_ERROR);

    // tbNXXg{bNX𐶐
    if ((list = SFZFlexListBoxControl::NewInstance(&error)) != null) {

        // eReiɐݒ肷
        if ((error = list->SetParent(GetThis())) == SFERR_NO_ERROR) {

            // tbNXXg{bNX̌ʃnho^
            error = list->RegisterHandler(
                SFXEventRange(SFEVT_RESPONDER_RESULT, SFEVT_RESPONDER_RESULT, SFP16_BEGIN, SFP16_END),
                XANDLER_INTERNAL(OnListResult)
            );

            if (error == SFERR_NO_ERROR) {

                // Ԗڂ̍ڂ̔wiFݒ肷
                list->SetEvenListColor(SFXRGBColor(0xFF, 0xFF, 0xCC, 0x00));

                // Ԗڂ̍ڂ̔wiFݒ肷
                list->SetOddListColor(SFXRGBColor(0xFF, 0xCC, 0xFF, 0x00));

                // ʏ펞̐ACg𒆉ɂ
                list->SetHorizontalAlign(SFZFlexListBoxControl::NORMAL, SFZFlexListBoxControl::HORIZONTAL_CENTER);

                // AXN[tO false ɐݒ肷
                list->SetScrollRepeat(false);

                // XN[o[̕ݒ肷
                list->SetScrollBarWidth(5);

                // I͕s\ɂ
                list->SetToggle(SFZFlexListBoxControl::TOGGLE_MULTIPLE_BODY_TEXT);

                SFYResponderSmp parent;
                if ((parent = GetParent()) != null) {

                    // Rei̐ẽ^Cv^uRg[łȂꍇɁA
                    if (parent->GetType() != SFZTabControl::CODE_TYPE) {

                        // Rg[ł UP L[ LEFT L[ɐݒ肷
                        list->SetScrollUpKey(AVK_LEFT);

                        // Rg[ł DOWN L[ RIGHT L[ɐݒ肷
                        list->SetScrollDownKey(AVK_RIGHT);
                    }
                }

                // _CNgANZXL[Lɂ
                list->SetAccessKeyEnable(true);

                // ACe\̂𗘗pčڂǉB
                // 񂾂łǉł邪摜𗘗pꍇ́A
                // ACe\̂𗘗pȒPB

                // ACe\̂ɗLtO true ɐݒ肷
                item.property.enable = true;

                // ACe\̂ɃANZXL[ƃR}hhcݒ肷
                // (hc͍gpȂ)
                item.property.key = 0;
                item.property.id = SFZFlexListBoxControl::INVALID_COMMAND_ID;

                // ACe\̂ɉ摜ݒ肷
                item.normal.body.icon = normal;
                item.select.body.icon = select;

                // W̍ڂǉ
                for (SInt32 i = 0;  i < 8; ++i) {

                    // ACe\̂ɕݒ肷
                    item.normal.header.text.Set(SFXWideString::Format("%02d", i));
                    item.normal.body.text.Set(SFXWideString::Format("List item %02d", i));
                    item.select.body.text.Set(SFXWideString::Format("The item %02d is selected.", i));

                    // ACe\̂Ƀ_CNgANZXL[ݒ肷
                    item.property.key = AVK_0 + i;

                    // ɑ}
                    if ((error = list->InsertLast(item)) != SFERR_NO_ERROR) {
                        break;
                    }
                }
                if (error == SFERR_NO_ERROR) {

                    // œKȗ̈vZĎ̈ݒ肷
                    list->SetRealBound(list->GetSuitableBound(GetLocalBound().Deflate(10, 10), SFYResponder::HORIZONTAL_CENTER, SFYResponder::VERTICAL_TOP));

                    // Ԃ (true, true, true, true) ɐݒ肷
                    list->SetState(true, true, true, true);

                    list->SetCurrentValue(1);

                    // ()
                    // K (oIȑ\)  true ɐݒ肵Ă
                    // ݒlݒ肷B
                    //
                }
            }
        }
    }
    return error;
}

// tbNXXg{bNX̌ʃnh
XANDLER_IMPLEMENT_VOIDRESULT(CustomContainer, OnListResult, invoker, reason, result)
{
    SFYResponderSmp parent;

    unused(invoker);
    unused(result);
    switch (reason) {
        case SFP16_RESULT_ESCAPE:
            if ((parent = GetParent()) != null) {

                // Rei̐e^uRg[ꍇɁA
                if (parent->GetType() == SFZTabControl::CODE_TYPE) {

                    // ReiI
                    Terminate();

                }

                // (Rei̐e ItsWindow ꍇɁA)
                else {

                    // Rei̐eɃNAL[̃Cxg𑗐M
                    parent->InvokeForward(SFXEvent(SFEVT_KEY, AVK_CLR, 0), false);

                }
            }
            break;
    }
    return;
}
