#ifndef __CUSTOMCONTAINER_HPP
#define __CUSTOMCONTAINER_HPP

#define TARGET_BUILD_DEBUG

#include <SophiaFramework.hpp>

//
// CustomContainer class (make and place flex list box control)
//

SFMTYPEDEFRESPONDER(CustomContainer)
#if 0
class CustomContainer : public SFYContainer
#endif
class CustomContainer : public SFZTabPage
{
    SFMSEALRESPONDER(CustomContainer)
    SFMRESPONDERINSTANTIATEFOUR(CustomContainer, SFZTabPage, SFYContainer, SFYWidget, SFYResponder)
public:

    // since 4-characters type of small alphabets and symbols is reserved
    // define ('C', 'C', 'T', 'N') of capital alphabets for CustomContainer type
    enum CodeEnum {
        CODE_TYPE = four_char_code('C', 'C', 'T', 'N')
    };
    SFMTYPEDEFTYPE(CodeEnum)

public:
    static CustomContainerSmp NewInstance(SFCErrorPtr exception = null);

    // make and place flex list box control
    SFCError Make(Void);

protected:
    explicit CustomContainer(Void) static_throws;
    virtual ~CustomContainer(Void);

    // drawing handler
    virtual Void HandleRenderRequest(SFXGraphicsPtr graphics) const;

private:

    // result handler of flex list box control
    XANDLER_DECLARE_VOIDRESULT(OnListResult)
};

#endif // __CUSTOMCONTAINER_HPP
