#include "ItsWindow.hpp"
#include "CustomContainer.hpp"
#include "ColorDef.hpp"

#define COLOR_ITS_WINDOW_BACK (SFXRGBColor(0xCC, 0xFF, 0xCC, 0x00))

// RXgN^
ItsWindow::ItsWindow(Void) static_throws
{
    if (static_try()) {
        SetType(CODE_TYPE);

        // ItsWindow ̃L[nho^
        static_throw(RegisterHandler(
            SFXEventRange(SFEVT_KEY, SFEVT_KEY, SFP16_BEGIN, SFP16_END),
            XANDLER_INTERNAL(OnKey)
        ));

        // ItsWindow ̔wiF𔖗ΐFɂ
        SetBackgroundColor(COLOR_ITS_WINDOW_BACK);
    }
}

// fXgN^
ItsWindow::~ItsWindow(Void)
{
}

// ItsWindow CX^X𐶐 NewInstance() ֐
ItsWindowSmp ItsWindow::NewInstance(SFCErrorPtr exception)
{
    return static_pointer_cast<ItsWindow>(Factory(:: new ItsWindow, exception));
}

// ItsWindow ̊eReiyуRg[̍쐬Ɣzu
SFCError ItsWindow::Make(Void)
{
    CustomContainerSmp container;
    SFZContainerScrollBarControlSmp bar;
    SFCError error(SFERR_NO_ERROR);

    #if 0
    // ėpRei쐬
    if ((container = SFZContainer::NewInstance(&error)) != null) {
    #endif

    // JX^Rei쐬
    if ((container = CustomContainer::NewInstance(&error)) != null) {

        // Rei̐eEBhEɐݒ肷
        if ((error = container->SetParent(GetThis())) == SFERR_NO_ERROR) {

            // ̈EBhẼ[J̈悩 (5, 5, 10, 5)  Deflate ̈ɐݒ肷
            container->SetRealBound(GetLocalBound().Deflate(5, 5, 10, 5));

            // z̈̈艺 150 L
            container->SetVirtualBound(container->GetLocalBound().AddHeight(150));

            // ReȉԂu++\+tH[JXvɂ܂Ƃ߂Đݒ肷
            container->SetState(true, true, true, true);

            // ReĩRg[쐬Ezu
            container->Make();

            #if 0

            // {^zuꍇ
            SFZTextButtonControlSmp button;

            // {^Rg[쐬
            if ((button = SFZTextButtonControl::NewInstance(&error)) != null) {

                // {^̐eReiɐݒ肷
                if ((error = button->SetParent(container)) == SFERR_NO_ERROR) {

                    // {^̕ "CenterMiddle" ɐݒ肷
                    if ((error = button->SetText("CenterMiddle")) == SFERR_NO_ERROR) {

                        // {^Reĩ[J̈̂ǐ^񒆂ɐݒ肷
                        button->SetRealBound(button->GetSuitableBound(container->GetLocalBound(), SFYResponder::HORIZONTAL_CENTER, SFYResponder::VERTICAL_MIDDLE));

                        // {^̏Ԃu++\+tH[JXvɂ܂Ƃ߂Đݒ肷
                        button->SetState(true, true, true, true);
                    }
                }
            }

            #endif
        }
    }
    if (error == SFERR_NO_ERROR) {

        // XN[o[Rg[ (Reip) 쐬
        if ((bar = SFZContainerScrollBarControl::NewInstance(&error)) != null) {

            // eEBhEɐݒ肷
            if ((error = bar->SetParent(GetThis())) == SFERR_NO_ERROR) {

                // ReỉẼׂXN[o[Rg[zu
                // XN[o[̕ 5
                SFXRectangle rx;
                rx.Set(container->GetRealBound());
                rx.AddX(rx.GetWidth());
                rx.SetWidth(5);
                bar->SetRealBound(rx);

                // XN[o[Rg[̏Ԃ u++s\+tH[JXvɂ܂Ƃ߂Đݒ肷
                // XN[o[Rg[ɂ͌ătH[JX͓Ȃ
                bar->SetState(true, true, false, false);

                /// XN[o[Rg[قǍ쐬Reiƌт
                error = bar->Bind(container);
            }
        }
    }
    return error;
}

// ItsWindow ̃L[nh
XANDLER_IMPLEMENT_BOOLEVENT(ItsWindow, OnKey, invoker, event)
{
    Bool result(false);

    unused(invoker);
    switch (event.GetP16()) {

        // NAL[ꂽƂ
        case AVK_CLR:

            // EBhEI
            Terminate();

            result = true;
            break;
    }
    return result;
}
