#include "MyWindow.hpp"
#include "ColorDef.hpp"

#define X_MARGIN 8
#define Y_MARGIN 8
#define COLOR_MY_WINDOW_BACK (SFXRGBColor(0xCC, 0xFF, 0xCC, 0x00))

enum {
    ID_BUTTON1 = 1,
    ID_BUTTON2
};

// MyWindow CX^X𐶐 NewInstance() ֐
MyWindowSmp MyWindow::NewInstance(SFCErrorPtr exception)
{
    // Factory() ֐g MyWindow CX^X𐶐܂B
    // Factory() ֐ SFYResponderSmp ^Ԃ̂
    // static_pointer_cast Zqg MyWindowSmp ^Ƀ_ELXgB
    return static_pointer_cast<MyWindow>(Factory(:: new MyWindow, exception));
}

// RXgN^
MyWindow::MyWindow(Void) : _ifShowHw(true) static_throws
{
    if (static_try()) {

        // X|_̃^Cvݒ肷
        SetType(CODE_TYPE);

        // MyWindow ̃L[nho^
        static_throw(RegisterHandler(
            SFXEventRange(SFEVT_KEY, SFEVT_KEY, SFP16_BEGIN, SFP16_END),
            XANDLER_INTERNAL(OnKey)
        ));
    }

    // MyWindow g̕`揈 MyWindow::HandleRenderRequest()I[o[ChċLq
    // MyWindow::HandleRenderRequest() SFYWidget NXɓo^ĂftHg̕`nhĂяô
    // `nh̓o^͕sv

    // MyWindow ̔wiF𔖗ΐFɐݒ肷
    SetBackgroundColor(COLOR_MY_WINDOW_BACK);
}

// fXgN^
MyWindow::~MyWindow(Void)
{
}

// MyWindow ̊eRg[̍쐬Ɣzu
SFCError MyWindow::Make(Void)
{
    SFXGrid offset(0, 0);
    SFCError error(SFERR_NO_ERROR);

    // MyWindow ŃRec`悷̈̍[ݒ肷
    offset.Add(X_MARGIN, Y_MARGIN);

    // MyWindow Ƀ{^Rg[쐬zu
    if ((error = CreateButtons(&offset)) != SFERR_NO_ERROR) {

        TRACE("button error");
        return error;
    }

    // MyWindow Ƀ`FbN{bNXRg[쐬zu
    if ((error = CreateCheckBoxes(&offset)) != SFERR_NO_ERROR) {

        TRACE("checkbox error");
        return error;
    }

    // MyWindow ɃWI{^Rg[쐬zu
    if ((error = CreateRadioButtons(&offset)) != SFERR_NO_ERROR) {

        TRACE("radiobutton error");
        return error;
    }

    // MyWindow ɃR{{bNXRg[쐬zu
    if ((error = CreateComboBox(&offset)) != SFERR_NO_ERROR) {

        TRACE("combobox error");
        return error;
    }

    // MyWindow ɃeLXgxRg[ƃGfBbg{bNXRg[쐬zu
    if ((error = CreatePassLine(&offset)) != SFERR_NO_ERROR) {

        TRACE("passline error");
        return error;
    }

    // MyWindow ɃXg{bNXRg[쐬zu
    if ((error = CreateListBox(&offset)) != SFERR_NO_ERROR) {

        TRACE("listbox error");
        return error;
    }

    return error;
}

// {^Rg[̍쐬Ɣzu
SFCError MyWindow::CreateButtons(SFXGridPtr offs)
{
    SFXGraphicsPtr graphics = SFXGraphics::GetInstance();
    SInt16Const height = graphics->GetFontHeight() + 4;                 // {^Rg[̍
    SInt16Const width = (GetLocalBound().GetWidth() - 4 * X_MARGIN) / 3;// {^Rg[̉
    SFXRectangle rect(*offs, SFXSize(width, height));                   // {^Rg[ 1 ̎̈
    SFCError error(SFERR_NO_ERROR);

    // {^Rg[ 1 쐬zu
    if ((_button1 = SFZTextButtonControl::NewInstance(&error)) != null) {

        // {^Rg[ 1 ̐eX|_ MyWindow ɐݒ肷
        error = _button1->SetParent(GetThis());

        if (error == SFERR_NO_ERROR) {

            // {^Rg[ 1 ̃nho^
            error = _button1->RegisterHandler(
                SFXEventRange(SFEVT_RESPONDER_RESULT, SFEVT_RESPONDER_RESULT, SFP16_BEGIN, SFP16_END),
                XANDLER_INTERNAL(OnButton12)
            );

            if (error == SFERR_NO_ERROR) {

                // {^Rg[ 1 ̃x "OK" ɏݒ肷
                error = _button1->SetText("OK");

                if (error == SFERR_NO_ERROR) {

                    // {^Rg[ 1 ʂ ID ݒ肵܂B
                    _button1->SetID(ID_BUTTON1);

                    // {^Rg[ 1 ̎̈ݒ肷
                    _button1->SetRealBound(rect);

                    // {^Rg[ 1 ̏Ԃu++\+tH[JXvɂ܂Ƃ߂Đݒ肷
                    _button1->SetState(true, true, true, true);
                }
            }
        }
    }

    // {^Rg[ 2 쐬zu
    if ((_button2 = SFZTextButtonControl::NewInstance(&error)) != null) {

        // {^Rg[ 2 ̐eX|_ MyWindow ɐݒ肷
        error = _button2->SetParent(GetThis());

        if (error == SFERR_NO_ERROR) {

            // {^Rg[ 2 ̃nho^
            error = _button2->RegisterHandler(
                SFXEventRange(SFEVT_RESPONDER_RESULT, SFEVT_RESPONDER_RESULT, SFP16_BEGIN, SFP16_END),
                XANDLER_INTERNAL(OnButton12)
            );

            if (error == SFERR_NO_ERROR) {

                // {^Rg[ 2 ̃x "NG" ɏݒ肷
                error = _button2->SetText("NG");

                if (error == SFERR_NO_ERROR) {

                    // {^Rg[ 2 ʂ ID ݒ肵܂B
                    _button2->SetID(ID_BUTTON2);

                    // {^Rg[ 2 ̎̈ݒ肷
                    rect.Offset(X_MARGIN + rect.GetWidth(), 0);
                    _button2->SetRealBound(rect);

                    // {^Rg[ 2 ̏Ԃu+s+s\+tH[JXvɂ܂Ƃ߂Đݒ肷
                    _button2->SetState(true, false, false, false);
                }
            }
        }
    }

    // {^Rg[ 3 쐬zu
    if ((_button3 = SFZTextButtonControl::NewInstance(&error)) != null) {

        // {^Rg[ 3 ̐eX|_ MyWindow ɐݒ肷
        error = _button3->SetParent(GetThis());

        if (error == SFERR_NO_ERROR) {

            // {^Rg[ 3 ̃nho^
            error = _button3->RegisterHandler(
                SFXEventRange(SFEVT_RESPONDER_RESULT, SFEVT_RESPONDER_RESULT, SFP16_BEGIN, SFP16_END),
                XANDLER_INTERNAL(OnButton3)
            );

            if (error == SFERR_NO_ERROR) {

                // {^Rg[ 3 ̃x "Off" ɏݒ肷
                error = _button3->SetText("Off");

                if (error == SFERR_NO_ERROR) {

                    // {^Rg[ 3 ̎̈vZ
                    rect.Offset(X_MARGIN + rect.GetWidth(), 0);

                    // {^Rg[ 3 ̎̈ݒ肷
                    _button3->SetRealBound(rect);

                    // {^Rg[ 3 ̏Ԃu++\+tH[JXvɂ܂Ƃ߂Đݒ肷
                    _button3->SetState(true, true, true, false);
                }
            }
        }
    }

    // ItZbgXV
    offs->AddY(rect.GetHeight() + Y_MARGIN);

    return error;
}

// `FbN{bNXRg[̍쐬Ɣzu
SFCError MyWindow::CreateCheckBoxes(SFXGridPtr offs)
{
    SFXGraphicsPtr graphics = SFXGraphics::GetInstance();
    SInt16Const height = graphics->GetFontHeight() + 4;                 // `FbN{bNXRg[̍
    SInt16Const width = (GetLocalBound().GetWidth() - 3 * X_MARGIN) / 2;// `FbN{bNXRg[̉
    SFXRectangle rect(*offs, width, height);                            // `FbN{bNXRg[ 1 ̎̈
    SFCError error(SFERR_NO_ERROR);

    // `FbN{bNXRg[ 1 쐬zu
    if ((_checkbox1 = SFZCheckboxControl::NewInstance(&error)) != null) {

        // `FbN{bNXRg[ 1 ̐eX|_ MyWindow ɐݒ肷
        error = _checkbox1->SetParent(GetThis());

        if (error == SFERR_NO_ERROR) {

            // `FbN{bNXRg[ 1 ̃nho^
            error = _checkbox1->RegisterHandler(
                SFXEventRange(SFEVT_RESPONDER_RESULT, SFEVT_RESPONDER_RESULT, SFP16_BEGIN, SFP16_END),
                XANDLER_INTERNAL(OnCheck)
            );

            if (error == SFERR_NO_ERROR) {

                // `FbN{bNXRg[ 1 ̃x "Hit" ɐݒ肷
                error = _checkbox1->SetText("Hit");

                if (error == SFERR_NO_ERROR) {

                    // `FbN{bNXRg[ 1 Ƀ`FbN
                    _checkbox1->SetCurrentValue(true);

                    // `FbN{bNXRg[ 1 l߂ɂ
                    _checkbox1->SetHorizontalAlign(SFZCheckboxControl::HORIZONTAL_LEFT);

                    // `FbN{bNXRg[ 1 ̎̈ݒ肷
                    _checkbox1->SetRealBound(rect);

                    // `FbN{bNXRg[ 1 ̏Ԃu++\+tH[JXvɂ܂Ƃ߂Đݒ肷
                    _checkbox1->SetState(true, true, true, false);
                }
            }
        }
    }

    // `FbN {bNXRg[ 2 쐬zu
    if ((_checkbox2 = SFZCheckboxControl::NewInstance(&error)) != null) {

        // `FbN{bNXRg[ 2 ̐eX|_ MyWindow ɐݒ肷
        error = _checkbox2->SetParent(GetThis());

        if (error == SFERR_NO_ERROR) {

            // `FbN{bNXRg[ 2 ̃nho^
            error = _checkbox2->RegisterHandler(
             SFXEventRange(SFEVT_RESPONDER_RESULT, SFEVT_RESPONDER_RESULT, SFP16_BEGIN, SFP16_END),
             XANDLER_INTERNAL(OnCheck)
            );

            // `FbN{bNXRg[ 2 ̃x "Run" ɐݒ肷
            error = _checkbox2->SetText("Run");

            if (error == SFERR_NO_ERROR) {

                // `FbN{bNXRg[ 2 ̎̈vZ
                rect.Offset(X_MARGIN + rect.GetWidth(), 0);

                // `FbN{bNXRg[ 2 lɂ
                _checkbox2->SetHorizontalAlign(SFZCheckboxControl::HORIZONTAL_LEFT);

                // `FbN{bNXRg[ 2 ̎̈ݒ肷
                _checkbox2->SetRealBound(rect);

                // `FbN{bNXRg[ 2 ̏Ԃu++\+tH[JXvɂ܂Ƃ߂Đݒ肷
                _checkbox2->SetState(true, true, true, false);
            }
        }
    }

    // ItZbgXV
    offs->AddY(rect.GetHeight() + Y_MARGIN);

    return error;
}

// WI{^Rg[̍쐬Ɣzu
SFCError MyWindow::CreateRadioButtons(SFXGridPtr offs)
{
    SFXGraphicsPtr graphics = SFXGraphics::GetInstance();
    SInt16Const height = graphics->GetFontHeight() + 4;                 // WI{^Rg[̍
    SInt16Const width = (GetLocalBound().GetWidth() - 3 * X_MARGIN) / 2;// WI{^Rg[̉
    SFXRectangle rect(*offs, width, height);                            // WI{^Rg[ 1 ̎̈
    SFCError error(SFERR_NO_ERROR);

    // WI{^Rg[ 1 쐬zu
    if ((_radio1 = SFZRadiobuttonControl::NewInstance(&error)) != null) {

        // WI{^Rg[ 1 ̐eX|_ MyWindow ɐݒ肷
        error = _radio1->SetParent(GetThis());

        if (error == SFERR_NO_ERROR) {

            // WI{^Rg[ 1 ̃nho^
            error = _radio1->RegisterHandler(
                SFXEventRange(SFEVT_RESPONDER_RESULT, SFEVT_RESPONDER_RESULT, SFP16_BEGIN, SFP16_END),
                XANDLER_INTERNAL(OnRadio)
            );

            if (error == SFERR_NO_ERROR) {

                // WI{^Rg[ 1 ̃x "Fast" ɐݒ肷
                error = _radio1->SetText("Fast");

                if (error == SFERR_NO_ERROR) {

                    // WI{^Rg[ 1 Ƀ`FbN
                    _radio1->SetCurrentValue(true);

                    // WI{^Rg[ 1 ɃAC
                    _radio1->SetHorizontalAlign(SFZRadiobuttonControl::HORIZONTAL_LEFT);

                    // WI{^Rg[ 1 ̎̈ݒ肷
                    _radio1->SetRealBound(rect);

                    // WI{^Rg[ 1 ̏Ԃu++\+tH[JXvɂ܂Ƃ߂Đݒ肷
                    _radio1->SetState(true, true, true, false);
                }
            }
        }
    }

    // WI{^Rg[ 2 쐬zu
    if ((_radio2 = SFZRadiobuttonControl::NewInstance(&error)) != null) {

        // WI{^Rg[ 2 ̐eX|_ MyWindow ɐݒ肷
        error = _radio2->SetParent(GetThis());

        if (error == SFERR_NO_ERROR) {

            // WI{^Rg[ 2 ̃nho^
            error = _radio2->RegisterHandler(
                SFXEventRange(SFEVT_RESPONDER_RESULT, SFEVT_RESPONDER_RESULT, SFP16_BEGIN, SFP16_END),
                XANDLER_INTERNAL(OnRadio)
            );

            if (error == SFERR_NO_ERROR) {

                // WI{^Rg[ 2 ̃x "Slow" ɐݒ肷
                error = _radio2->SetText("Slow");

                if (error == SFERR_NO_ERROR) {

                    // WI{^Rg[ 2 ̎̈vZ
                    rect.Offset(X_MARGIN + rect.GetWidth(), 0);

                    // WI{^Rg[ 2 ɃAC
                    _radio2->SetHorizontalAlign(SFZRadiobuttonControl::HORIZONTAL_LEFT);

                    // WI{^Rg[ 2 ̎̈ݒ肷
                    _radio2->SetRealBound(rect);

                    // WI{^Rg[ 2 ̏Ԃu++\+tH[JXvɂ܂Ƃ߂Đݒ肷
                    _radio2->SetState(true, true, true, false);
                }
            }
        }
    }

    // WI{^Rg[ 1 2 O[vɂ
    _radio1->Group(_radio2);

    // ItZbgXV
    offs->AddY(rect.GetHeight() + Y_MARGIN);

    return error;
}

// R{ {bNX̍쐬
SFCError MyWindow::CreateComboBox(SFXGridPtr offs)
{
    SFXGraphicsPtr graphics = SFXGraphics::GetInstance();
    SInt16Const height = graphics->GetFontHeight() + 4;             // R{{bNXRg[̍
    SInt16Const width = (GetLocalBound().GetWidth() - 2 * X_MARGIN);// R{{bNXRg[̉
    SFXRectangle rect(*offs, width, height);                        // R{{bNXRg[̎̈
    SFCError error(SFERR_NO_ERROR);

    // R{{bNXRg[쐬zu
    if ((_combobox = SFZComboBoxControl::NewInstance(&error)) != null) {

        // R{{bNXRg[̐eX|_ MyWindow ɐݒ肷
        error = _combobox->SetParent(GetThis());

        if (error == SFERR_NO_ERROR) {

            // R{{bNXRg[̌ʃnho^
            error = _combobox->RegisterHandler(
                SFXEventRange(SFEVT_RESPONDER_RESULT, SFEVT_RESPONDER_RESULT, SFP16_BEGIN, SFP16_END),
                XANDLER_INTERNAL(OnComboBox)
            );

            if (error == SFERR_NO_ERROR) {

                // R{{bNXێtbNXXg{bNXɒlnho^
                error = _combobox->GetListBoxControl()->RegisterHandler(
                    SFXEventRange(SFEVT_RESPONDER_VALUE, SFEVT_RESPONDER_VALUE, SFP16_VALUE_CURRENT, SFP16_VALUE_CURRENT),
                    XANDLER_INTERNAL(OnComboListValue)
                );

                if (error == SFERR_NO_ERROR) {

                    // R{{bNXRg[ɍڂݒ肷
                    SFXWideString item[] = {"First", "Second", "Third", "Four", "Five", "Six", "Seven", "Eight", "Nine", "Ten"};

                    // zōڂ܂Ƃ߂Ēǉ
                    error = _combobox->InsertLast(item, lengthof(item));

                    if (error == SFERR_NO_ERROR) {

                        // R{{bNXRg[̎̈ݒ肷
                        _combobox->SetRealBound(rect);

                        // R{{bNXRg[̏Ԃu++\+tH[JXvɂ܂Ƃ߂Đݒ肷
                        _combobox->SetState(true, true, true, false);
                    }
                }
            }
        }
    }

    // ItZbgXV
    offs->AddY(rect.GetHeight() + Y_MARGIN);

    return error;
}

// eLXgxRg[ƃGfBbg{bNXRg[̍쐬Ɣzu
SFCError MyWindow::CreatePassLine(SFXGridPtr offs)
{
    SFXRectangle rect;
    SFCError error(SFERR_NO_ERROR);

    // eLXgxRg[쐬zu
    if ((_singleTextLabel = SFZSingleTextLabelControl::NewInstance(&error)) != null) {

        // eLXgxRg[̐eX|_ MyWindow ɐݒ肷
        error = _singleTextLabel->SetParent(GetThis());

        if (error == SFERR_NO_ERROR) {

            // eLXgxRg[̃x "PW:" ɐݒ肷
            error = _singleTextLabel->SetText("PW:");

            if (error == SFERR_NO_ERROR) {

                // eLXgxRg[̍œKȎ̈vZ
                rect.Set(*offs, _singleTextLabel->GetSuitableBound().GetSize());

                // eLXgxRg[̎̈ݒ肷
                _singleTextLabel->SetRealBound(rect);

                // eLXgxRg[̏Ԃu{{s{tH[JXvɂ܂Ƃ߂Đݒ肷
                _singleTextLabel->SetState(true, true, false, false);
            }
        }
    }

    // GfBbg{bNXRg[쐬zu
    if ((_singleEditBox = SFZSingleEditBoxControl::NewInstance(&error)) != null) {

        // GfBbg{bNXRg[̐eX|_ MyWindow ɐݒ肷
        error = _singleEditBox->SetParent(GetThis());

        if (error == SFERR_NO_ERROR) {

            // GfBbg{bNXRg[̃nho^
            error = _singleEditBox->RegisterHandler(
                SFXEventRange(SFEVT_RESPONDER_RESULT, SFEVT_RESPONDER_RESULT, SFP16_BEGIN, SFP16_END),
                XANDLER_INTERNAL(OnSingleEditBox)
            );

            if (error == SFERR_NO_ERROR) {

                // pX[h [hɐݒ肷
                error = _singleEditBox->SetPasswordMode(true);

                if (error == SFERR_NO_ERROR) {

                    // ő啶 10 ɂ
                    error = _singleEditBox->SetMaximumLength(10);

                    if (error == SFERR_NO_ERROR) {

                        // p݂̂̓͂Ɍ肷
                        _singleEditBox->SetInputMode(AEE_TM_LETTERS | AEE_TM_NUMBERS);

                        // ɃeLXg񂹂܂B
                        _singleEditBox->SetHorizontalAlign(SFZSingleEditBoxControl::HORIZONTAL_LEFT);

                        // GfBbg{bNXRg[̎̈vZ
                        rect.Offset(rect.GetWidth(), 0);
                        rect.SetRight(GetLocalBound().GetWidth() - X_MARGIN);

                        // GfBbg{bNXRg[̎̈ݒ肷
                        _singleEditBox->SetRealBound(rect);

                        // GfBbg{bNXRg[̏Ԃu{{\{tH[JXvɂ܂Ƃ߂Đݒ肷
                        _singleEditBox->SetState(true, true, true, false);
                    }
                }
            }
        }
    }

    // ItZbgXV
    offs->AddY(rect.GetHeight() + Y_MARGIN);

    return error;
}

// Xg{bNXRg[̍쐬Ɣzu
SFCError MyWindow::CreateListBox(SFXGridPtr offs)
{
    SFXEventRange::AtomRecConst range[] = {                         // Xg{bNXɓo^nh̃Cxg͈
        {SFEVT_RESPONDER_RESULT, SFEVT_RESPONDER_RESULT, SFP16_BEGIN, SFP16_END},
        {SFEVT_RESPONDER_VALUE, SFEVT_RESPONDER_VALUE, SFP16_VALUE_CURRENT, SFP16_VALUE_CURRENT}
    };
    SFYHandler::RuleRec rule[lengthof(range)];                      // nh[
    SInt16Const width = (GetLocalBound().GetWidth() - 2 * X_MARGIN);// Xg{bNXRg[̉
    SFXRectangle rect(*offs, width, 0);                             // Xg{bNXRg[̎̈
    SFCError error(SFERR_NO_ERROR);

    // Xg{bNXRg[쐬zu
    if ((_listbox = SFZListBoxControl::NewInstance(&error)) != null) {

        // Xg{bNXRg[̐eX|_ MyWindow ɐݒ肷
        error = _listbox->SetParent(GetThis());

        if (error == SFERR_NO_ERROR) {

            // Xg{bNXRg[̃nh[ݒ肷
            rule[0].spp = XANDLER_FUNCTION(OnListBox);              // Xg{bNXRg[̌ʃnhݒ
            rule[0].reference = this;                               // MyWindow ̃|C^ (OnListBox ̎̂CX^X̃|C^)ݒ
            rule[1].spp = XANDLER_FUNCTION(OnListValue);            // Xg{bNXRg[̒lnhݒ
            rule[1].reference = this;                               // MyWindow ̃|C^ (OnListValue ̎̂CX^X̃|C^)ݒ

            // Xg{bNXRg[̃nh܂Ƃ߂ēo^
            error = _listbox->RegisterHandler(atomic_cast(range), rule, lengthof(range));

            if (error == SFERR_NO_ERROR) {

                // Xg{bNXRg[ɕ\鍀
                SFXWideString item[] = {"First", "Second", "Third", "Four", "Five", "Six", "Seven", "Eight", "Nine", "Ten"};

                for (SInt16 i = 0; i < lengthof(item); ++i) {

                    // Xg{bNXRg[ɍڂǉ
                    error = _listbox->InsertLast(item[i]);

                    if (error != SFERR_NO_ERROR) {
                        break;
                    }
                }
                if (error == SFERR_NO_ERROR) {

                    // Xg{bNXRg[ł UP L[ LEFT L[ɐݒ肷
                    _listbox->SetUpKey(AVK_LEFT);

                    // Xg{bNXRg[ł DOWN L[ RIGHT L[ɐݒ肷
                    _listbox->SetDownKey(AVK_RIGHT);

                    // ̈̍ő 80 ɐݒ肷
                    rect.SetHeight(80);

                    // Xg{bNXRg[̎̈ݒ肷
                    // ͍̈̍œK̈擾֐ŒĂ
                    _listbox->SetRealBound(_listbox->GetSuitableBound(rect).SetWidth(rect.GetWidth()));

                    // Xg{bNXRg[̏Ԃu{{\{tH[JXvɂ܂Ƃ߂Đݒ肷
                    _listbox->SetState(true, true, true, false);
                }
            }
        }
    }

    // ItZbgXV
    offs->AddY(rect.GetHeight() + Y_MARGIN);

    return error;
}

// MyWindow ̕`nh
Void MyWindow::HandleRenderRequest(SFXGraphicsPtr graphics) const
{
    // `s߂ SFXGraphics CX^X͑ 1 (graphics)Ƃēn
    // MyWindow ̃[J̈̍オ`̈̌_ƂȂ
    // wi̓RXgN^Őݒ肵 SFYWidget::SetBackgroundColor() Őݒ肵ΐFœhׂ

    // _flagShowHw tO true ̂Ƃ "Hello Window" \
    if (_ifShowHw) {

        // MyWindow ̃[J̈撆ɕ "Hello Window" `悷
        // [J̈ GetLocalBound()Ŏ擾
        graphics->DrawSingleText("Hello Window", GetLocalBound(), COLOR_BLACK);
    }
    return;
}

// L[nh (MyWindow őOʂɂƂɃL[ƌĂяo)
// invoker ͂̃nhĂяoX|_BSFYResponderPtr ^ (̏ꍇAMyWindow)
// event ̓L[CxgBSFXEventConstRef ^
XANDLER_IMPLEMENT_BOOLEVENT(MyWindow, OnKey, invoker, event)
{
    SFYResponderSmp parent;
    Bool result(false);

    unused(invoker);
    switch (event.GetP16()) {

        // NA[ L[ꂽƂ
        case AVK_CLR:

            // MyWindow 
            Terminate();

            // ̒iKł MyWindow ̓q[vɂ܂cĂ
            // MyWindow ͎QƃJEg 0 ɂȂƂɃq[v
            // helloworld AvP[VNX MyWindow ێĂ̂
            // MyWindow  helloworld AvbgIƂɃq[v

            result= true;
            break;
    }
    return result;
}

// {^Rg[ 1  2 pnh̎
XANDLER_IMPLEMENT_VOIDRESULT(MyWindow, OnButton12, invoker, reason, result)
{
    unused(reason);
    unused(result);

    // ꂽ{^ Rg[擾
    // invoker  SFYResponderPtr ^Ȃ̂ SFZTextButtonControlPtr ^Ƀ_ELXg
    SFZTextButtonControlPtr pushed(static_cast<SFZTextButtonControlPtr>(invoker));

    // ΂ɂȂ{^ Rg[擾
    UInt32 pairID = (pushed->GetID() == ID_BUTTON1) ? ID_BUTTON2 : ID_BUTTON1;
    SFZTextButtonControlSmp pair = static_pointer_cast<SFZTextButtonControl>(GetThis()->GetChildFront(pairID));

    // ꂽ{^ Rg[̃x "NG" ɐݒ肷
    pushed->SetText("NG");

    // ꂽ{^ Rg[̏Ԃusvɂ
    // \AtH[JXԂ͗DԂ̂ŁAsɂ邾ł悢
    pushed->SetStateActive(false);

    // ΂ɂȂ{^ Rg[̃x "OK" ɐݒ肷
    pair->SetText("OK");

    // ΂ɂȂ{^ Rg[̏Ԃu{\{tH[JXvɐݒ肷
    pair->SetStateActive(true);
    pair->SetStateEnable(true);
    pair->SetStateFocus(true);

    return;
}

// {^Rg[ 3 pnh̎
XANDLER_IMPLEMENT_VOIDRESULT(MyWindow, OnButton3, invoker, reason, result)
{
    unused(invoker);
    unused(reason);
    unused(result);

    // `悷镶 on/off ؂ւł悤ɂ܂ B
    // {^Rg[ 3 ̃x "Off"  "On"A܂ "On"  "Off" ɐ؂ւ
    _ifShowHw = !_ifShowHw;
    _button3->SetText(_ifShowHw ? "Off" : "On");

    // MyWindow ĕ`̈Ƃēo^
    // ܂A"Hello Window" \̗L𔽉f܂B
    Invalidate();

    // Invalidate() ֐̈ɉw肵ȂꍇAMyWindow ̎̈Ŝĕ`̈Ƃēo^
    // Invalidate() ֐̎sɂAMyWindow ̓Cxg[v̍۔ɋN`GWɍĕ`悷ׂ̈Ƃēo^

    return;
}

// `FbN{bNXRg[pnh̎
XANDLER_IMPLEMENT_VOIDRESULT(MyWindow, OnCheck, invoker, reason, result)
{
    unused(invoker);
    unused(reason);
    unused(result);

    // x̕擾
    SFXWideString label1(_checkbox1->GetText());
    SFXWideString label2(_checkbox2->GetText());

    // x̕ƌݒlfobO\
    TRACE("%S: %d", label1.GetCString(), _checkbox1->GetCurrentValue());
    TRACE("%S: %d", label2.GetCString(), _checkbox2->GetCurrentValue());

    return;
}

// WI{^Rg[pnh̎
XANDLER_IMPLEMENT_VOIDRESULT(MyWindow, OnRadio, invoker, reason, result)
{
    unused(invoker);
    unused(reason);
    unused(result);

    // x̕擾
    SFXWideString label1(_radio1->GetText());
    SFXWideString label2(_radio2->GetText());

    // x̕ƌݒlfobO\
    TRACE("%S: %d", label1.GetCString(), _radio1->GetCurrentValue());
    TRACE("%S: %d", label2.GetCString(), _radio2->GetCurrentValue());

    return;
}

// R{{bNXRg[pʃnh̎
XANDLER_IMPLEMENT_VOIDRESULT(MyWindow, OnComboBox, invoker, reason, result)
{
    unused(invoker);
    unused(reason);

    if (reason == SFP16_RESULT_OK) {

        // Iڂ̕擾
        // result : Iڂ̔ԍ
        SFXWideString string(_combobox->GetItemText(result));

        // Iڂ̔ԍƕfobO\
        TRACE("'CB%d: %S' is selected.", result, string.GetCString());

        // Xg{bNXRg[R{{bNXRg[Ɠ
        _listbox->SetCurrentValue(result);
    }
    return;
}

// R{{bNXێtbNXXgRg[plnh̎
XANDLER_IMPLEMENT_VOIDVALUE(MyWindow, OnComboListValue, invoker, reason, value)
{
    unused(invoker);
    unused(reason);

    // tH[JX̂鍀ڔԍfobO\
    // value : tH[JX̂鍀ڔԍ
    TRACE("'CB%d'", value);

    return;
}

// GfBbg{bNXRg[pnh̎
XANDLER_IMPLEMENT_VOIDRESULT(MyWindow, OnSingleEditBox, invoker, reason, result)
{
    unused(invoker);
    unused(reason);
    unused(result);

    // ^̃pX[hƔr
    if (_singleEditBox->GetText().Compare("pass") == 0) {

        TRACE("password: authenticated!");
    } else {
        TRACE("password: can't be authenticated...");
    }

    return;
}

// Xg{bNXRg[pʃnh̎
XANDLER_IMPLEMENT_VOIDRESULT(MyWindow, OnListBox, invoker, reason, result)
{
    unused(invoker);
    unused(reason);

    if (reason == SFP16_RESULT_OK) {

        // Iꂽڂ̕擾
        // result : Iڂ̔ԍ
        SFXWideString string(_listbox->GetItemText(result));

        // Iڂ̔ԍƕfobO\
        TRACE("'LB%d: %S' is selected.", result, string.GetCString());

        // Xg{bNXRg[R{{bNXRg[Ɠ
        _combobox->SetCurrentValue(result);
    }
    return;
}

// Xg{bNXRg[plnh̎
XANDLER_IMPLEMENT_VOIDVALUE(MyWindow, OnListValue, invoker, reason, value)
{
    unused(invoker);
    unused(reason);

    // tH[JX̂鍀ڔԍfobO\
    // value : tH[JX̂鍀ڔԍ
    TRACE("'LB%d'", value);
    return;
}
