#include "TabWindow.hpp"
#include "MyWindow.hpp"
#include "CustomContainer.hpp"
#include "ColorDef.hpp"
#include "UserEvent.hpp"

#define COLOR_TAB COLOR_WHITE

// RXgN^
TabWindow::TabWindow(Void)
{
    if (static_try()) {
        SetType(CODE_TYPE);

        // L[nh̓o^
        static_throw(RegisterHandler(
            SFXEventRange(SFEVT_KEY, SFEVT_KEY, SFP16_BEGIN, SFP16_END),
            XANDLER_INTERNAL(OnKey)
        ));
    }
}

// fXgN^
TabWindow::~TabWindow(Void)
{
}

// CX^X쐬
TabWindowSmp TabWindow::NewInstance(SFCErrorPtr exception)
{
    return static_pointer_cast<TabWindow>(Factory(:: new TabWindow, exception));
}

// X|_쐬
SFCError TabWindow::Make()
{
    MyWindowSmp myWindow;
    CustomContainerSmp customContainer;
    SFCError error(SFERR_NO_ERROR);

    // ^uRg[쐬
    if ((_tab = SFZTabControl::NewInstance(&error)) != null) {

        // ^uRg[̐eX|_EBhEɐݒ肷
        error = _tab->SetParent(GetThis());

        if (error == SFERR_NO_ERROR) {

            // ^uRg[ɔzFnho^
            error = _tab->RegisterHandler(
                SFXEventRange(SFEVT_USER_COLOR, SFEVT_USER_COLOR, SFP16_USER_COLOR, SFP16_USER_COLOR),
                XANDLER_INTERNAL(OnTabColor)
            );

            if (error == SFERR_NO_ERROR) {

                // ^uRg[̎̈ݒ肷
                _tab->SetRealBound(GetLocalBound());

                // ^uRg[̊eFݒ肷
                _tab->SetBackgroundColor(COLOR_TAB);

                // ^uRg[̋E`悷悤ɐݒ肷
                _tab->SetDrawBorder(true);

                // ^uRg[̃XN[o[\Ȃ
                _tab->SetScrollBarWidth(0);
                _tab->SetScrollBarControl(SFYScrollBarControlSmp::EmptyInstance());

                // ^uRg[Ɉxɕ\^u̐ 2 y[Wɂ
                _tab->SetFieldValue(2);

                // ^uRg[̏Ԃu{{\{tH[JXvɐݒ肷
                _tab->SetState(true, true, true, true);

                // MyWindow ̍쐬 (MyWindow ̐eNX SFZTabPage ɕύXĂ)
                if ((myWindow = MyWindow::NewInstance(&error)) != null) {

                    // MyWindow ̐eX|_^uRg[ɐݒ肷
                    // MyWindow ̎̈̓^uRg[̎̈Ń^ű`̈ɎIɐݒ肳
                    error = myWindow->SetParent(_tab);

                    if (error == SFERR_NO_ERROR) {

                        // MyWindow ̃^CgeLXgݒ肷(^üɕ\)
                        myWindow->SetTitle("Controls");

                        // MyWindow ̃qgeLXgݒ肷
                        myWindow->SetHint("This is MyWindow");

                        // MyWindow ̏Ԃu{{\{tH[JXvɐݒ肷
                        myWindow->SetState(true, true, true, true);

                        // MyWindow ̃X|_쐬zu
                        myWindow->Make();

                        // CustomContainer ̍쐬 (CustomContainer ̐eNX SFZTabPage ɕύXĂ)
                        if ((customContainer = CustomContainer::NewInstance(&error)) != null) {

                            error = customContainer->SetParent(_tab);

                            if (error == SFERR_NO_ERROR) {

                                // CustomContainer ̃^CgeLXgݒ肷(^üɕ\)
                                customContainer->SetTitle("Container");

                                // CustomContainer ̃qgeLXgݒ肷
                                customContainer->SetHint("This is CustomContainer");

                                // CustomContainer ̏Ԃu{{\{tH[JXvɐݒ肷
                                customContainer->SetState(true, true, true, false);

                                // CustomContainer ̃X|_쐬zu
                                customContainer->Make();

                                // ׂẴ^uy[WɂēK؂ȉz̈vZ
                                // ̏ꍇAMyWindow ̎̈ MyWindow ̃Rg[܂肫Ȃ
                                // ߁AMyWindow ̉z̈́ARg[傤ǎ܂肫TCY
                                // ܂ŊgB
                                _tab->AdjustPages();

                                // 2 ڂ̃y[W (CustomContainer) I
                                _tab->FocusPage(1);
                            }
                        }
                    }
                }
            }
        }
    }
    return error;
}

// EBhẼL[nh
XANDLER_IMPLEMENT_BOOLEVENT(TabWindow, OnKey, invoker, event)
{
    SFYResponderSmp parent;
    Bool result(false);

    unused(invoker);
    switch (event.GetP16()) {
        case AVK_CLR:

            // EBhEI
            Terminate();

            result = true;
            break;
    }
    return result;
}

// ^uRg[̔zFnh
XANDLER_IMPLEMENT_VOIDUSERCOLOR(TabWindow, OnTabColor, invoker, reason, color)
{
    unused(invoker);
    unused(reason);

    // ^uRg[̔wiݒ肷
    _tab->SetBackgroundColor(color->base);

    // ^uRg[̃qg׃xJ[ݒ肷
    _tab->SetHintBevelColor(SFXBevelColor(color->light, color->base, color->dark));

    // ^uRg[̂׃xJ[ݒ肷
    _tab->SetTabBevelColor(SFXBevelColor(color->light, color->base, color->dark));

    // ׂẴ^uy[W擾^CgFݒ肷
    for (SInt16 i = 0; i < _tab->GetPageCount(); ++i) {
        SFZTabPageSmp page = _tab->GetPage(i);
        page->SetTextColor(color->selFore);
    }

    return;
}
