//      helloworld.hpp

#ifndef __HELLOWORLD_HPP
#define __HELLOWORLD_HPP

#define TARGET_BUILD_DEBUG

#include <SophiaFramework.hpp>
#include "helloworld.bid"
#include "UserColor.hpp"
#include "MyWindow.hpp"
#include "ItsWindow.hpp"
#include "TabWindow.hpp"

enum {

    // \tgL[Rg[̃xeLXgɌŗL̎ʎq蓖Ă
    KEY_TEXT_EXIT   = 1,
    KEY_TEXT_SELECT,
    KEY_TEXT_CONFIG,
    KEY_TEXT_BACK

};

enum {

    // \tgL[Rg[̃\tgL[j[ɌŗL̎ʎq蓖Ă
    KEY_MENU_TOP    = 1,
    KEY_MENU_WINDOW,
    KEY_MENU_TEXTMENU,
    KEY_MENU_DIALOG

};

//
//  helloworld AvP[VNX
//

//  ֗Ȍ^𐶐}N
SFMTYPEDEFCLASS(helloworld)

//  helloworld  SFYApplication p
class helloworld : public SFYApplication {

    // CX^X̃Rs[֎~}N
    SFMSEALCOPY(helloworld)

private:

    // MyWindow ̃X}[g|C^
    MyWindowSmp _myWindow;

    // ItsWindow ̃X}[g|C^
    ItsWindowSmp _itsWindow;

    // SFZTextMenu ̃X}[g|C^
    SFZTextMenuSmp _textMenu;

    // TabWindow ̃X}[g|C^
    TabWindowSmp _tabWindow;

    // SFZSoftKeyControl ̃X}[g|C^
    SFZSoftKeyControlSmp _softkey;

    // SFZTitlePlainFrame ̃X}[g|C^ (EBhEpt[)
    SFZTitlePlainFrameSmp _windowFrame;

    // SFZTitleBevelFrame ̃X}[g|C^ (_CAOpt[)
    SFZTitleBevelFrameSmp _dialogFrame;

public:

    // t@Ng֐
    static SFCInvokerPtr Factory(Void);

private:

    // RXgN^
    explicit helloworld(Void) static_throws;

    // fXgN^
    virtual ~helloworld(Void);

    // MyWindow 쐬Ɣzu
    SFCError MakeMy(Void);

    // SFZTextMenu 쐬Ɣzu
    SFCError MakeMenu(Void);

    // ItsWindow 쐬Ɣzu
    SFCError MakeIts(Void);

    // TabWindow 쐬Ɣzu
    SFCError MakeTab(Void);

    // bZ[W_CAO̍쐬Ɣzu
    SFCError MakeColorDialog(SFXWideStringConstRef title, UserColorConstRef color);

    // \tgL[j[̍쐬
    SFCError MakeSoftMenu(UInt32 key);

    // EBhEpt[̍쐬Ɣzu
    SFCError MakeWindowFrame(SFXWideStringConstRef title);

    // _CAOpt[̍쐬Ɣzu
    SFCError MakeDialogFrame(SFXWideStringConstRef title);

    // \tgL[j[pxeLXg̓o^
    SFCError RegisterSoftText(Void);

    // j[̐F܂Ƃ߂Đݒ
    Void SetMenuColors(UserColorConstRef color);

    // gщʂ\tgL[Rg[̈擾
    SFXRectangle GetContentBound(Void) const;

    // `nh
    XANDLER_DECLARE_VOIDRENDER(OnRenderRequest)

    // L[nh
    XANDLER_DECLARE_BOOLEVENT(OnKey)

    // j[ʃnh
    XANDLER_DECLARE_VOIDRESULT(OnMenuResult)

    // helloworld ̃\tgL[nh
    XANDLER_DECLARE_VOIDEVENT(OnSoftKey)

    // eLXgj[̃\tgL[nh
    XANDLER_DECLARE_VOIDEVENT(OnMenuSoftKey)

    // EBhẼ\tgL[nh
    XANDLER_DECLARE_VOIDEVENT(OnWindowSoftKey)

    // EBhẼL[nh
    XANDLER_DECLARE_BOOLEVENT(OnWindowKey)

    // _CAǑʃnh
    XANDLER_DECLARE_VOIDRESULT(OnDialogResult)

    // \tgL[Rg[̔zFnh
    XANDLER_DECLARE_VOIDUSERCOLOR(OnSoftColor)

    // EBhẼt[̔zFnh
    XANDLER_DECLARE_VOIDUSERCOLOR(OnWindowFrameColor)
};

#endif // __HELLOWORLD_HPP //
